.586
.model flat,stdcall
option casemap:none
.xmm

include \masm32\include\windows.inc
include \masm32\macros\macros.asm
include \masm32\macros\timers.asm

include \masm32\include\masm32.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\gdi32.inc

includelib \masm32\lib\masm32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\gdi32.lib

szCopyMMX proto :DWORD,:DWORD
szCopyXMM proto :DWORD,:DWORD

.data

LOOP_COUNT equ 100000000
align 16
TestPiece db "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789!ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789!!",0
align 16
TestPiece2 db 128 dup(0)

.code

start:

	counter_begin LOOP_COUNT,REALTIME_PRIORITY_CLASS
	invoke szCopyMMX,addr TestPiece,addr TestPiece2
	counter_end
	print ustr$(eax)
	print chr$(" cycles with MMX",13,10)
	
	counter_begin LOOP_COUNT,REALTIME_PRIORITY_CLASS
	invoke szCopyXMM,addr TestPiece,addr TestPiece2
	counter_end
	print ustr$(eax)
	print chr$(" cycles with XMM",13,10)
	exit

option prologue:none
option epilogue:none
szCopyMMX proc lpSource:DWORD,lpDest:DWORD

	mov ecx,[esp+4]
	mov edx,[esp+8]
	
	align 16
	CopyQwords:
	pxor mm1,mm1					;mm1 = 00 00 00 00 00 00 00 00
	movq mm0,[ecx]					;mm0 = next 8 bytes
	pcmpeqb mm1,mm0					;compare bytes in mm0 and mm1 - if equal then byte in mm1 = FF
	pmovmskb eax,mm1				;put msb of each byte in mm1 into the bit in al
	test al,al						;if any bit = 1 then there was a zero byte
	jnz CopyStragglers
	movq [edx],mm0					;copy the qword
	add ecx,8						;next 8 bytes
	add edx,8
	jmp CopyQwords
	
	CopyStragglers:
	mov al,[ecx]					;copy the string (including zero byte)
	mov [edx],al
	add ecx,1						;next byte
	add edx,1
	test al,al						;carry on until zero
	jnz CopyStragglers
	
	ret 8
	
szCopyMMX endp

szCopyXMM proc lpSource:DWORD,lpDest:DWORD
	
	mov ecx,[esp+4]
	mov edx,[esp+8]
	
	align 16
	CopyOwords:
	movdqa xmm0,[ecx]
	pxor xmm1,xmm1
	pcmpeqb xmm1,xmm0
	pmovmskb eax,xmm1
	test ax,ax
	jnz CopyStragglers
	movdqa [edx],xmm0
	add ecx,16
	add edx,16
	jmp CopyOwords
	
	CopyStragglers:
	mov al,[ecx]
	mov [edx],al
	add ecx,1
	add edx,1
	test al,al
	jnz CopyStragglers
	
	ret 8

szCopyXMM endp

end start